//=============================================================================
//
//  CLASS LightBuffer
//
//=============================================================================

#ifndef RAYTRACER_LIGHTBUFFER_H
#define RAYTRACER_LIGHTBUFFER_H

//== INCLUDES =================================================================
#include "Types.h"
#include "Surface.h"
#include "Accelerator.h"

//== CLASS DEFINITION =========================================================

/*!
	Uniform Grid.

*/
class LightBuffer: public Accelerator
{
//-------------------------------------------------------------- constructors
public:
	//! standard constructor
	LightBuffer( const SurfaceList *scene );
    
    // Destructor
    ~LightBuffer();

//--------------------------------------------------------------- intersections

    bool intersect( const Ray&     clRay, 
	   			    const double  t0, 
				    const double  t1, 
					TracingContext&  tContext ) const;
					
};
//=============================================================================
#endif // RAYTRACER_LightBuffer_H
//=============================================================================