//=============================================================================
//
//  Main Window
//
//=============================================================================
#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include <QImage>
#include <QMainWindow>
#include <QLabel>
#include "raytracingwidget.h"
#include "glwidget.h"
class   QAction;
class   QMenu;
class   QTextEdit;
class   QSlider;
class   QCheckBox;
class	QLineEdit;
class   QComboBox;
class MainWindow : public QMainWindow
{
    Q_OBJECT


public:
    MainWindow();
public slots :
	void about();
	void setImageSize();
	void setRecursionDepth();
signals:
	void updateImageSizeRT( int );
	void updateRecursionDepthRT( int );

protected:
    void    closeEvent( QCloseEvent *event );

private:
    void            createActions();
    void            createMenus();
    void            createStatusBar();
    void            createMainFrame();
    void            readsettings();
    void            createSliders();
    QSlider         *createSlider( int min, int max );
    QSlider         *m_xSlider;
    QSlider         *m_ySlider;
    QSlider         *m_zSlider;
    QSlider         *m_xRotSlider;
    QSlider         *m_yRotSlider;
    QSlider         *m_zRotSlider;
    QPushButton     *m_selectNextObjectButton;
    QPushButton     *m_renderSceneButton;
    QString         m_curFile;
    QMenu           *m_fileMenu;
    QMenu           *m_editMenu;
    QMenu           *m_helpMenu;
    RaytracingArea  *m_raytraceArea;
    GLWidget        *m_glArea;
    QAction         *m_openSceneAct;
    QAction         *m_saveImageAct;
    QAction         *m_exitAct;
    QAction         *m_renderAct;
    QAction         *m_aboutAct;
    QAction         *m_aboutQtAct;
    QCheckBox       *m_setRayMode;
    QCheckBox       *m_setDisplayUpdate;
	QLineEdit		*m_imageSizeEdit;
	QPushButton		*m_setImageSize;
	QLineEdit		*m_recursionDepthEdit;
	QPushButton		*m_setRecursionDepth;
	QComboBox       *m_choseAccelerator;
};
#endif
